
#ifndef SGRAPH_H
#define SGRAPH_H
 
#include <iostream>
#include <vector>
#include <fstream>

using namespace std;

class sgraph
{

  friend ostream & operator<<(ostream & out, const sgraph &g);

 public:

  sgraph();
  sgraph(vector<vector<int> > list);

  vector<vector<int> > edges;

  vector<int> vertices;
  vector<int> generators;
  vector<int> spanningtree;

  vector<int> new_order;

  void initGraph(vector<int> pair);
  bool addEdge(vector<int> pair);
  bool extendpath(int goal, vector<int> &path);
  vector<int> findpath(int j, int k);
  
  //  vector<vector<int> > fundamental_group(int basept);
  void fundamental_group(int basept, vector<vector<int> > &gens, vector<vector<bool> > &orientation);

  void export_fg_with_relations(int basept, string tag, vector<vector<int> > rels, vector<vector<bool> > orients);

};

#endif
